-----------------------------------------------------------------------------------------------
-- Client Lua Script for HAK
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- HAK Module Definition
-----------------------------------------------------------------------------------------------
local HAK = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
local kcrSelectedText = ApolloColor.new("UI_BtnTextHoloPressedFlyby")
local kcrNormalText = ApolloColor.new("UI_BtnTextHoloNormal")

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function HAK:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	o.tItems = {} -- keep track of all the list items
	o.wndSelectedListItem = nil -- keep track of which list item is currently selected
	o.tItems_A = {} -- keep track of all the list items
	o.wndSelectedListItem_A = nil -- keep track of which list item is currently selected


    return o
end

function HAK:Init()

if self.SequenceList == nil then self.SequenceList = {} end
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- HAK OnLoad
-----------------------------------------------------------------------------------------------
function HAK:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("HAK.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- HAK OnDocLoaded
-----------------------------------------------------------------------------------------------
function HAK:OnDocLoaded()


	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "HAKForm", nil, self)
	    self.wndEditAnim = Apollo.LoadForm(self.xmlDoc, "EditAnimationForm", nil, self)
	    self.wndMessageBox= Apollo.LoadForm(self.xmlDoc, "MessageBox", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
		-- item list
		self.wndItemList = self.wndMain:FindChild("ItemList")
		self.wndItemList_A = self.wndEditAnim:FindChild("AnimationItemList")
	    self.wndMain:Show(false, true)
		self.wndEditAnim:Show(false,true);
		self.wndMessageBox:Show(false,true);
		
						self.SelectedIdLo = 0
				self.SelectedIdHi = 0
				self.SelectedName = ""
				self.ItemHandle =0;
				self.pixielist={}
				self.pixielist.pixie={}
				self.PlayList = {}
				self.PlayList.sequence = {}

		

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("hak", "OnHAKOn", self)
Apollo.RegisterEventHandler("HousingFreePlaceDecorQuery", 		"OnFreePlaceDecorQuery", self)

		self.timer = ApolloTimer.Create(0.100, true, "OnTimer", self)

		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- HAK Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/anim"
function HAK:OnHAKOn()
	self.wndMain:Invoke() -- show the window
	
	-- populate the item list
	self:PopulateItemList()
	self:PopulateItemList_A(nil)

end

-- on timer
function HAK:OnTimer()
--[[sequence.CurrentFrame=1
	sequence.TotalFrames=10
	sequence.objects={}
	sequence.objects.object = {}
	sequence.objects.object[1] = {}
	sequence.objects.object[1].objectinfo = {};
	sequence.objects.object[1].objectinfo.Name = name
	sequence.objects.object[1].objectinfo.IdHi = idhi
	sequence.objects.object[1].objectinfo.IdLo = idlo
	sequence.objects.object[1].frames = {}
	sequence.objects.object[1].frames.frame = {}
	sequence.objects.object[1].frames.frame[1]= {}
	sequence.objects.object[1].frames.frame[1].x = x
	sequence.objects.object[1].frames.frame[1].y = y
	sequence.objects.object[1].frames.frame[1].z = z
	sequence.objects.object[1].frames.frame[1].yawn = ya
	sequence.objects.object[1].frames.frame[1].pitch = pi
	sequence.objects.object[1].frames.frame[1].roll = ro
	sequence.objects.object[1].frames.frame[1].s = s
	sequence.objects.object[1].frames.frame[1].keyframe = true;
	sequence.objects.object[1].frames.frame[1].smooth = false;
	for i = 2,frames do
	sequence.objects.object[1].frames.frame[i]= {}
	sequence.objects.object[1].frames.frame[i].x = -999
	sequence.objects.object[1].frames.frame[i].y = 0
	sequence.objects.object[1].frames.frame[i].z = 0
	sequence.objects.object[1].frames.frame[i].yawn = 0
	sequence.objects.object[1].frames.frame[i].pitch = 0
	sequence.objects.object[1].frames.frame[i].roll = 0
	sequence.objects.object[1].frames.frame[i].s = 0
	sequence.objects.object[1].frames.frame[i].keyframe = false;
	sequence.objects.object[1].frames.frame[i].smooth = false;
]]--
	-- Do your timer-related stuff here.
	if HousingLib.IsHousingWorld() == false then return; end
	if self.PlayList ~= nil then
		if #self.PlayList.sequence > 0 then
			for i = 1,#self.PlayList.sequence do


				if self.PlayList.sequence[i] ~= nil then
				self.PlayList.sequence[i].CurrentFrame = self.PlayList.sequence[i].CurrentFrame + 1
						--	Print("Gonna try to play "..self.PlayList.sequence[i].CurrentFrame );
				if self.PlayList.sequence[i].CurrentFrame > self.PlayList.sequence[i].TotalFrames then self.PlayList.sequence[i].CurrentFrame = 1 end;
				--Print("Objects " ..#self.PlayList.sequence[i].objects.object);
				local obs = self.PlayList.sequence[i].objects
				--Print("Objects " ..#obs);
				for j = 1,#self.PlayList.sequence[i].objects.object do
					self:MoveObject(self.PlayList.sequence[i].objects.object[j].objectinfo, self.PlayList.sequence[i].objects.object[j].frames.frame[self.PlayList.sequence[i].CurrentFrame])
				--Print("Moved it");
				
				end
				
				end
				
			end
		end
	end
	
	
end

function HAK:MoveObject(info, location)
--Print(table.tostring(info));
if location.x == -999 then return end
local itemhandler = HousingLib.PreviewPlacedDecor(info.IdLo, info.IdHi)
if itemhandler ~=  nil then
HousingLib.SetDecorPosition(location.x, location.y, location.z)
HousingLib.SetDecorRotation(location.pitch, location.roll, location.yawn)
HousingLib.ScaleDecor(location.s)
HousingLib.FreePlaceDecorDisplacement_Confirm()


end
end

-----------------------------------------------------------------------------------------------
-- HAKForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function HAK:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function HAK:OnCancel()
	self.wndMain:Close() -- hide the window
end


function HAK:AddNewSequenceClick( wndHandler, wndControl, eMouseButton )
if self.SequenceList ~= nil then 
newnumber = #self.SequenceList +1
else
newnumber = 1

end

self.SequenceList[newnumber] = {}
self.SequenceList[newnumber].Name = "Enter Title"
for i = 1, #self.SequenceList do
		if self.tItems[i] ~= nil then
		if self.SequenceList[i].Name == self.SequenceList[newnumber].Name  then
			self.SequenceList[newnumber].Name = self.SequenceList[newnumber].Name.." - "..math.random(999999)
			--Print("Changed name to "..self.SequenceList[newnumber].Name);
		end
		end
	end

self.SequenceList[newnumber].TotalFrames = 30
self.SequenceList[newnumber].CurrentFrame = 1
self.SequenceList[newnumber].objects = {}
self.SequenceList[newnumber].objects.object = {}


		self:AddItem(newnumber)
		self.tItems[newnumber]:FindChild("EditButton"):Enable(false);
		self.tItems[newnumber]:FindChild("Text"):SetData(self.SequenceList[newnumber]);
		self.tItems[newnumber]:FindChild("Text"):SetText(self.SequenceList[newnumber].Name);
		self:OnListItemSelected(self.tItems[newnumber],self.tItems[newnumber]);

self.wndItemList:ArrangeChildrenVert()
end

-----------------------------------------------------------------------------------------------
-- ItemList Functions
-----------------------------------------------------------------------------------------------
-- populate item list
function HAK:PopulateItemList()
	-- make sure the item list is empty to start with
	self:DestroyItemList()
	
    -- add 20 items
local j=0;
if self.SequenceList ~= nil then
	for i = 1,#self.SequenceList do
		if self.SequenceList[i].Name ~= nil then
		j=j+1
        self:AddItem(j)
		self.tItems[j]:FindChild("EditButton"):Enable(false);
		self.tItems[j]:FindChild("Text"):SetText(self.SequenceList[i].Name);
		self.tItems[j]:FindChild("Text"):SetData(self.SequenceList[i]);
		end
	end
end	
	-- now all the item are added, call ArrangeChildrenVert to list out the list items vertically
	self.wndItemList:ArrangeChildrenVert()
end

-- clear the item list
function HAK:DestroyItemList()
	-- destroy all the wnd inside the list
	for idx,wnd in ipairs(self.tItems) do
		wnd:Destroy()
	end

	-- clear the list item array
	self.tItems = {}
	self.wndSelectedListItem = nil
end

-- add an item into the item list
function HAK:AddItem(i)
	-- load the window item for the list item
	local wnd = Apollo.LoadForm(self.xmlDoc, "ListItem", self.wndItemList, self)
	
	-- keep track of the window item created
	self.tItems[i] = wnd

	-- give it a piece of data to refer to 
	local wndItemText = wnd:FindChild("Text")
	if wndItemText then -- make sure the text wnd exist
		--wndItemText:SetText("item " .. i) -- set the item wnd's text to "item i"
		wndItemText:SetTextColor(kcrNormalText)
	end
	wnd:SetData(i)
end

-- when a list item is selected
function HAK:OnListItemSelected(wndHandler, wndControl)
    -- make sure the wndControl is valid
    if wndHandler ~= wndControl then
        return
    end
    
    -- change the old item's text color back to normal color
    local wndItemText
    if self.wndSelectedListItem ~= nil then
        wndItemText = self.wndSelectedListItem:FindChild("Text")
		self.wndSelectedListItem:FindChild("EditButton"):Enable(false)
        wndItemText:SetTextColor(kcrNormalText)
    end
    
	-- wndControl is the item selected - change its color to selected
	self.wndSelectedListItem = wndControl
	wndItemText = self.wndSelectedListItem:FindChild("Text")
	self.wndSelectedListItem:FindChild("EditButton"):Enable(true)
    wndItemText:SetTextColor(kcrSelectedText)
    
	--Print( "item " ..  self.wndSelectedListItem:GetData() .. " is selected.")
end


---------------------------------------------------------------------------------------------------
-- ListItem Functions
---------------------------------------------------------------------------------------------------

function HAK:ListItemEditButtonClick( wndHandler, wndControl, eMouseButton )


local test = wndHandler:GetParent();
--Print("Button"..test:GetData());
self.wndEditAnim:Invoke();
self.wndMain:Show(false,true);
local thetable = self.wndSelectedListItem:FindChild("Text"):GetData()
--if thetable == nil then thetable = {}
self:PopulateItemList_A(thetable)

if thetable ~= nil then
if thetable.Name ~= nil then
self.wndEditAnim:FindChild("TitleBox"):SetText(thetable.Name)
end

if thetable.TotalFrames ~= nil then
self:UpdatePixies(thetable.TotalFrames ,nil);
else
self:UpdatePixies(10 ,nil);

end
end
HousingLib.SetEditMode(true);
self.wndEditAnim:FindChild("AddKeyFrameButton"):Enable(false)
self.wndEditAnim:FindChild("RemoveKeyframeButton"):Enable(false)
self.wndEditAnim:FindChild("SetPositionButton"):Enable(false)

--self.wndMessageBox:Invoke();
end


function HAK:OnFreePlaceDecorQuery(nItemHandle, bFreePlaceMode, eDecorTypeForEdit) -- This is first and fires once
--Print("Got here");


    
if 	self.nFreePlaceDecorHandle ~= nItemHandle then -- select a decor item to edit it
		-- shut down the vender UI
		

		
		self.nFreePlaceDecorHandle = nItemHandle
		
		if self.nFreePlaceDecorHandle ~= 0 then
		local tScreenInfo = HousingLib.GetDecorIconInfo(nItemHandle);
		--HousingLib.PreviewDecor_Cancel();
		--HousingLib.FreePlaceDecorDisplacement_Cancel();
		local aaa = HousingLib.GetPlacedDecorList();
		for i = 1,#aaa do
			if aaa[i].strName == tScreenInfo.strName then
			local nItemHandle2 = HousingLib.PreviewPlacedDecor(aaa[i].nDecorId, aaa[i].nDecorIdHi)

			--Print(nItemHandle2.."handle");
			local tScreenInfo2 = HousingLib.GetDecorIconInfo(nItemHandle2)
			if tScreenInfo.fWorldPosX == tScreenInfo2.fWorldPosX and tScreenInfo.fWorldPosY == tScreenInfo2.fWorldPosY and tScreenInfo.fWorldPosZ == tScreenInfo2.fWorldPosZ and tScreenInfo.fPitch == tScreenInfo2.fPitch and tScreenInfo.fYaw == tScreenInfo2.fYaw and tScreenInfo.fRoll == tScreenInfo2.fRoll  then
				self.SelectedIdLo = aaa[i].nDecorId
				self.SelectedIdHi = aaa[i].nDecorIdHi
				self.SelectedName = aaa[i].strName
			--	Print("Found it!");
		  	    nItemHandle = HousingLib.PreviewPlacedDecor(self.SelectedIdLo , self.SelectedIdHi)
		self.ItemHandle = nItemHandle;

				HousingLib.ApplyPreviewEffectToDecor(nItemHandle)
				--HousingLib.pre
				local found = false;
				if #self.tItems_A > 0 then
				for i = 1,#self.tItems_A do
					if self.tItems_A[i] ~= nil then
				  local dd = self.tItems_A[i]:FindChild("Text"):GetData()
					if dd.Name == self.SelectedName and dd.IdLo == self.SelectedIdLo and dd.IdHi == self.SelectedIdHi then
						self:OnListItemSelected_A(self.tItems_A[i],self.tItems_A[i])
						found = true;
					end
					end
				end
				if found == false then 
					if self.wndSelectedListItem_A ~= nil then
      			  	wndItemText = self.wndSelectedListItem_A:FindChild("Text")
		        	wndItemText:SetTextColor(kcrNormalText)
					self.wndSelectedListItem_A:FindChild("SelIcon"):SetSprite("abilities:sprAbility_CapEnd1");
					self.wndSelectedListItem_A = nil
    				end

				
				end
				end
				
				
				--	Print(table.tostring(self.tItems_A[1]:FindChild("Text"):GetData()));
--	self.wndSelectedListItem_A
				
				
				
				return true
			end
			

			
			end
		
		
		end
		
--	Print (table.tostring(aaa[1]));

		    -- Activate the decor icon
            
            -- Do this to trick it into moving straight to the glowing state
         --   HousingLib.ApplyPreviewEffectToDecor(nItemHandle)
            
        end
	end
end

function HAK:StopPlayButtonClick( wndHandler, wndControl, eMouseButton )
wndControl:GetParent():FindChild("StopPlayButton"):Show(false,true);
wndControl:GetParent():FindChild("StartPlayButton"):Show(true,true);
local dummy = wndControl:GetParent():FindChild("Text"):GetData();
--Print(dummy.Name)
self:StopaSequence(dummy.Name)
end

function HAK:StartPlayButtonClick( wndHandler, wndControl, eMouseButton )
wndControl:GetParent():FindChild("StopPlayButton"):Show(true,true);
wndControl:GetParent():FindChild("StartPlayButton"):Show(false,true);
self.PlayList.sequence[#self.PlayList.sequence+1] = wndControl:GetParent():FindChild("Text"):GetData();
end

function HAK:DeleteTotalSequenceClick( wndHandler, wndControl, eMouseButton )
local kill  = wndControl:GetParent():FindChild("Text"):GetData();
if kill ~= nil then killname = kill.Name end

if killname ~= nil then 
--Print(killname)


   local newlist = {}
	i=0;
	local lala = 0;
	for i= 1,#self.SequenceList   do
        -- for each player in our list, create a table using the name as our key
        
        -- save a table version of the color
		if self.SequenceList[i] ~= nil then
		local seq = self.SequenceList[i]

        if seq ~= nil and killname ~= seq.Name then 
			lala=lala+1
			newlist[lala] = {}
			newlist[lala] = seq; 
		end
		if killname == seq.Name then
		 --self.tItems[i]:Destroy();
		end
		end


    end
self.SequenceList = nil;
self.SequenceList = newlist
end
self:DestroyItemList();
self:PopulateItemList();



end

-----------------------------------------------------------------------------------------------
-- ItemList Functions
-----------------------------------------------------------------------------------------------
-- populate item list
function HAK:PopulateItemList_A(sequence)
	if sequence == nil then
	sequence = {}
	sequence.CurrentFrame=1
	sequence.TotalFrames=10
	sequence.objects={}
	sequence.objects.object = {}
	--[[
	sequence.objects.object[1] = {}
	sequence.objects.object[1].objectinfo = {};
	sequence.objects.object[1].objectinfo.Name = "dummy"
	sequence.objects.object[1].objectinfo.IdHi = 111
	sequence.objects.object[1].objectinfo.IdLo = 222
	sequence.objects.object[1].frames = {}
	sequence.objects.object[1].frames.frame = {}
	for i = 1,200 do
	
	sequence.objects.object[1].frames.frame[i]= {}
	sequence.objects.object[1].frames.frame[i].x = 0
	sequence.objects.object[1].frames.frame[i].y = 0
	sequence.objects.object[1].frames.frame[i].z = 0
	sequence.objects.object[1].frames.frame[i].yawn = 0
	sequence.objects.object[1].frames.frame[i].pitch = 0
	sequence.objects.object[1].frames.frame[i].roll = 0
	sequence.objects.object[1].frames.frame[i].s = 0
	sequence.objects.object[1].frames.frame[i].keyframe = false;
	sequence.objects.object[1].frames.frame[i].smooth = false;
	end
	sequence.objects.object[1].frames.frame[1].keyframe = true;
	]]--

	end
	
	self.wndEditAnim:FindChild("CurrentFrameBox"):SetText("1")
	self.wndEditAnim:FindChild("MaxFramesEditBox"):SetText(sequence.TotalFrames)
	self.wndEditAnim:FindChild("FrameSelectSlider"):SetMinMax(1,sequence.TotalFrames);

	-- make sure the item list is empty to start with
	self:DestroyItemList_A()
	
    -- add 20 items
	for i = 1,#sequence.objects.object do
        self:AddItem_A(i)
		self.tItems_A[i]:FindChild("Text"):SetData(sequence.objects.object[i].objectinfo)
		self.tItems_A[i]:FindChild("Text"):SetText(sequence.objects.object[i].objectinfo.Name)
		self.tItems_A[i]:FindChild("Timeline"):SetData(sequence.objects.object[i].frames)
	end
	
	-- now all the item are added, call ArrangeChildrenVert to list out the list items vertically

	self.wndItemList_A:ArrangeChildrenVert()
	
end

-- clear the item list
function HAK:DestroyItemList_A()
	-- destroy all the wnd inside the list
	for idx,wnd in ipairs(self.tItems_A) do
		wnd:Destroy()
	end

	-- clear the list item array
	self.tItems_A = {}
	self.wndSelectedListItem_A = nil
end

-- add an item into the item list
function HAK:AddItem_A(i)
	-- load the window item for the list item
	local wnd = Apollo.LoadForm(self.xmlDoc, "ListItemEditor", self.wndItemList_A, self)
	
	-- keep track of the window item created
	self.tItems_A[i] = wnd

	-- give it a piece of data to refer to 
	local wndItemText = wnd:FindChild("Text")
	if wndItemText then -- make sure the text wnd exist
		wndItemText:SetText("item " .. i) -- set the item wnd's text to "item i"
		wndItemText:SetTextColor(kcrNormalText)
	end
	wnd:SetData(i)
end

-- when a list item is selected
function HAK:OnListItemSelected_A(wndHandler, wndControl)
    -- make sure the wndControl is valid
    if wndHandler ~= wndControl then
        return
    end
    
    -- change the old item's text color back to normal color
    local wndItemText
    if self.wndSelectedListItem_A ~= nil then
        wndItemText = self.wndSelectedListItem_A:FindChild("Text")
        wndItemText:SetTextColor(kcrNormalText)
		self.wndSelectedListItem_A:FindChild("SelIcon"):SetSprite("abilities:sprAbility_CapEnd1");
    end
    
	-- wndControl is the item selected - change its color to selected
	self.wndSelectedListItem_A = wndControl
	wndItemText = self.wndSelectedListItem_A:FindChild("Text")
    wndItemText:SetTextColor(kcrSelectedText)
		self.wndSelectedListItem_A:FindChild("SelIcon"):SetSprite("abilities:sprAbility_CapEnd3");
    
	--Print( "item " ..  self.wndSelectedListItem_A:GetData() .. " is selected.")
	self.ItemHandle = HousingLib.PreviewPlacedDecor(self.wndSelectedListItem_A:FindChild("Text"):GetData().IdLo,self.wndSelectedListItem_A:FindChild("Text"):GetData().IdHi)

end


---------------------------------------------------------------------------------------------------
-- ListItem Functions
---------------------------------------------------------------------------------------------------

function HAK:ListItemEditButtonClick_A( wndHandler, wndControl, eMouseButton )
local test = wndHandler:GetParent();
--Print("Button"..test:GetData());
self.wndEditAnim:Invoke();

end


---------------------------------------------------------------------------------------------------
-- EditAnimationForm Functions
---------------------------------------------------------------------------------------------------

function HAK:TotalFramesCountChanged( wndHandler, wndControl, strText )
local newmax = tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText())
 self.wndEditAnim:FindChild("FrameSelectSlider"):SetMinMax(1,newmax);

--fix objects
for i = 1,#self.tItems_A do
 local frames = self.tItems_A[i]:FindChild("Timeline"):GetData()
 if #frames.frame < newmax then
  for j = #frames.frame+1,newmax do
	frames.frame[j] = {}
	frames.frame[j].x = -999
	frames.frame[j].y = 0
	frames.frame[j].z = 0

	frames.frame[j].yawn = 0
	frames.frame[j].pitch = 0
	frames.frame[j].roll = 0
	frames.frame[j].s = 0
	frames.frame[j].smooth = false;

	
	frames.frame[j].keyframe = false;
	self.tItems_A[i]:FindChild("Timeline"):SetData(frames)
  end


 end

 


end
self:UpdatePixies(tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText()), nil)


end

function HAK:AddKeyframeClick( wndHandler, wndControl, eMouseButton )
--[[local o =  self.wndEditAnim:FindChild("SmoothTransitionCheckbox");
for key,value in pairs(getmetatable(o)) do
    Print(key, value)
end]]--
self.wndSelectedListItem_A:FindChild("Timeline"):GetData().frame[tonumber(self.wndEditAnim:FindChild("CurrentFrameBox"):GetText())].keyframe = true;

self:UpdatePixies(tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText()), nil)
self:SmoothenFrames();
self:UpdateNumbers();


end

function HAK:FrameSelectSliderScroll( wndHandler, wndControl, fNewValue, fOldValue, bOkToChange )
self:UpdateNumbers();
self.wndEditAnim:FindChild("CurrentFrameBox"):SetText(round(fNewValue));
return true;
end

function HAK:CurrentFrameBoxChanged( wndHandler, wndControl, strText )
self:UpdateNumbers();
self.wndEditAnim:FindChild("FrameSelectSlider"):SetValue(tonumber(self.wndEditAnim:FindChild("CurrentFrameBox"):GetText()))
end

function HAK:AnimationEditFormSizeChanged( wndHandler, wndControl )
--w min/max 658
--h min 288


end

function HAK:AddCurrentObjectToSequence( wndHandler, wndControl, eMouseButton )
if self.SelectedName ~= "" then
for j = 1,#self.tItems_A do
local bla = self.tItems_A[j]:FindChild("Text"):GetData()
if bla.Name == self.SelectedName and bla.IdHi == self.SelectedIdHi and bla.IdLo == self.SelectedIdLo then
 return;
end
end

local i = #self.tItems_A +1;


local nItemHandle = HousingLib.PreviewPlacedDecor(self.SelectedIdLo , self.SelectedIdHi)
local tScreenInfo = HousingLib.GetDecorIconInfo(nItemHandle)
		--fWorldPosZ and tScreenInfo.fPitch 
local dummy = self:BasicObject(self.SelectedName,self.SelectedIdHi, self.SelectedIdLo, tScreenInfo.fWorldPosX, tScreenInfo.fWorldPosY, tScreenInfo.fWorldPosZ,tScreenInfo.fPitch,tScreenInfo.fYaw,tScreenInfo.fRoll,tScreenInfo.fScaleCurrent,tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText()))
local dum2 = {}
dum2.Name = self.SelectedName
dum2.IdHi = self.SelectedIdHi
dum2.IdLo = self.SelectedIdLo

		self:AddItem_A(i)
		self.tItems_A[i]:FindChild("Text"):SetData(dum2)
		self.tItems_A[i]:FindChild("Text"):SetText(dum2.Name)
		self.tItems_A[i]:FindChild("Timeline"):SetData(dummy.frames)
self:OnListItemSelected_A(self.tItems_A[i],self.tItems_A[i])

end
self.wndItemList_A:ArrangeChildrenVert()
self:UpdatePixies(tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText()), nil)

end



function HAK:UpdatePixies(maxframes, index)

local allowsetindex = false;
if index == nil then allowsetindex = true; end

if self.pixielist == nil then 
 self.pixielist  = {}

 else
--Print("Going to kill pixies");
    local	i=0


	while self.pixielist[i+1] ~= nil do
	i=i+1
	if allowsetindex == true then index = i; end
	if index == i then
	local j = 0
	while j < maxframes do 
	j=j+1
	if self.pixielist[i].pixie[j] ~= nil and self.tItems_A[i] ~= nil then
	
	self.tItems_A[i]:FindChild("Timeline"):DestroyPixie(self.pixielist[i].pixie[j])
	--Print("Killed one");
	self.pixielist[i].pixie[j] = nil;
	end
	end
	end
end
end


keyframecounter = 0;

linewidth = 300 / maxframes;

 for i = 1, #self.tItems_A do
 if allowsetindex == true then index = i; end
 if i == index then
	self.pixielist[i] = {}
	self.pixielist[i].pixie = {}
	local tl = self.tItems_A[i]:FindChild("Timeline")
	local tldata = tl:GetData();
	--Print("i : "..tostring(i).." frames"..#tldata.frame)
	for m = 1, maxframes do 
	if tldata.frame[m] == nil then 
	tldata.frame[m] = {}
	tldata.frame[m].x = -999
	tldata.frame[m].y = 0
	tldata.frame[m].z = 0
	tldata.frame[m].yawn = 0
	tldata.frame[m].pitch = 0
	tldata.frame[m].roll = 0
	tldata.frame[m].s = 0
	tldata.frame[m].smooth = false
	tldata.frame[m].keyframe = false;
	
	
	
	end

	if tldata.frame[m].keyframe == true then
	 self.pixielist[i].pixie[m] = self:AddPixie(tl,0,(m-1)*linewidth,5,linewidth,30)
	keyframecounter =keyframecounter +1
	end
	end
	


 end
 end
--Print("keyframes done"..keyframecounter)
--Print("Returning "..#self.pixielist.pixie.." pixies");

end


function HAK:SmoothenFrames()
	
	local theframes = self.wndSelectedListItem_A:FindChild("Timeline"):GetData()
	local maxframes = tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText())
	local i = maxframes
	
	while i > 1 do
		if theframes.frame[i].keyframe == true then
			local smooth = theframes.frame[i].smooth
			if smooth == true then
			local j = i -1
			while theframes.frame[j].keyframe == false and j ~= 1 do
				j=j-1	 
			end
			local deltaframes = i-j
			--Print("Delta frames :"..deltaframes);
			--fix frames
			local dx = theframes.frame[i].x - theframes.frame[j].x
			local dy = theframes.frame[i].y - theframes.frame[j].y
			local dz = theframes.frame[i].z - theframes.frame[j].z
			
			local dpi = theframes.frame[i].pitch - theframes.frame[j].pitch
			local dya = theframes.frame[i].yawn - theframes.frame[j].yawn
			local dro = theframes.frame[i].roll  - theframes.frame[j].roll
			local ds = theframes.frame[i].s  - theframes.frame[j].s
			local m = 0
			while m < deltaframes do
			 m=m+1
			if theframes.frame[i-m].keyframe == false then
				theframes.frame[i-m].x = theframes.frame[i].x - ((dx/deltaframes)*m)
				theframes.frame[i-m].y = theframes.frame[i].y - ((dy/deltaframes)*m)
				theframes.frame[i-m].z = theframes.frame[i].z - ((dz/deltaframes)*m)
				theframes.frame[i-m].pitch = theframes.frame[i].pitch - ((dpi/deltaframes)*m)
				theframes.frame[i-m].yawn = theframes.frame[i].yawn - ((dya/deltaframes)*m)
				theframes.frame[i-m].roll = theframes.frame[i].roll - ((dro/deltaframes)*m)
				theframes.frame[i-m].s = theframes.frame[i].s - ((ds/deltaframes)*m)


			end
			
			end
			i=j+1
			else
			
			local j = i -1
			while theframes.frame[j].keyframe == false and j ~= 1 do
				j=j-1	 
			end
			local deltaframes = i-j
			--Print("Delta frames :"..deltaframes);
			--fix frames

			local m = 0
			while m < deltaframes do
			 m=m+1
			if theframes.frame[i-m].keyframe == false then
				theframes.frame[i-m].x = -999
				theframes.frame[i-m].y = 0
				theframes.frame[i-m].z = 0
				theframes.frame[i-m].pitch = 0
				theframes.frame[i-m].yawn = 0
				theframes.frame[i-m].roll = 0
				theframes.frame[i-m].s = 0


			end
			
			end
			i=j+1

			
			
			end
			
			
			
			
		end
		i=i-1
	end
	self.wndSelectedListItem_A:FindChild("Timeline"):SetData(theframes )
	self:UpdateNumbers();

end



function HAK:UpdateNumbers()
if self.wndSelectedListItem_A == nil then return end
local theframedata = self.wndSelectedListItem_A:FindChild("Timeline"):GetData()
if theframedata ~= nil then theframedata = theframedata.frame[tonumber(self.wndEditAnim:FindChild("CurrentFrameBox"):GetText())] end
if theframedata == nil then return end

if theframedata.keyframe == true then
self.wndEditAnim:FindChild("RemoveKeyframeButton"):Enable(true)
self.wndEditAnim:FindChild("AddKeyFrameButton"):Enable(false)
self.wndEditAnim:FindChild("SetPositionButton"):Enable(true)
self.wndEditAnim:FindChild("SmoothTransitionCheckbox"):Enable(true)



else
self.wndEditAnim:FindChild("RemoveKeyframeButton"):Enable(false)
self.wndEditAnim:FindChild("AddKeyFrameButton"):Enable(true)
self.wndEditAnim:FindChild("SetPositionButton"):Enable(false)
self.wndEditAnim:FindChild("SmoothTransitionCheckbox"):Enable(false)

end



self.wndEditAnim:FindChild("SmoothTransitionCheckbox"):SetCheck(theframedata.smooth);

self.wndEditAnim:FindChild("XPos"):SetText(string.format("%.2f", theframedata.x))
self.wndEditAnim:FindChild("YPos"):SetText(string.format("%.2f", theframedata.y))
self.wndEditAnim:FindChild("ZPos"):SetText(string.format("%.2f", theframedata.z))
self.wndEditAnim:FindChild("Yaw"):SetText(string.format("%.2f", theframedata.yawn))
self.wndEditAnim:FindChild("Pitch"):SetText(string.format("%.2f", theframedata.pitch))
self.wndEditAnim:FindChild("Roll"):SetText(string.format("%.2f", theframedata.roll))
self.wndEditAnim:FindChild("Scale"):SetText(string.format("%.2f", theframedata.s))




end


function HAK:AddPixie(target,style,x,y,w,h)
local stylestring = "BasicSprites:RedFill"
if style == 1 then
stylestring = "BasicSprites:RedFill"

end



return target:AddPixie({
  strText = "",
  strFont = "CRB_Interface10",
  bLine = true, fWidth = w,
  strSprite = stylestring,
  cr = {a=1,r=1.00,g=0.00,b=0.00},
  loc = {
fPoints = {0.0,0.0,0.0,0.0},
    nOffsets = {x + (w/2), y, x + (w/2), y+h}
    
  }
})



end


function HAK:BasicObject(name, idhi, idlo, x,y,z, pi,ya,ro, s,frames)

local sequence = {}
	sequence.CurrentFrame=1
	sequence.TotalFrames=10
	sequence.objects={}
	sequence.objects.object = {}
	sequence.objects.object[1] = {}
	sequence.objects.object[1].objectinfo = {};
	sequence.objects.object[1].objectinfo.Name = name
	sequence.objects.object[1].objectinfo.IdHi = idhi
	sequence.objects.object[1].objectinfo.IdLo = idlo
	sequence.objects.object[1].frames = {}
	sequence.objects.object[1].frames.frame = {}
	sequence.objects.object[1].frames.frame[1]= {}
	sequence.objects.object[1].frames.frame[1].x = x
	sequence.objects.object[1].frames.frame[1].y = y
	sequence.objects.object[1].frames.frame[1].z = z
	sequence.objects.object[1].frames.frame[1].yawn = ya
	sequence.objects.object[1].frames.frame[1].pitch = pi
	sequence.objects.object[1].frames.frame[1].roll = ro
	sequence.objects.object[1].frames.frame[1].s = s
	sequence.objects.object[1].frames.frame[1].keyframe = true;
	sequence.objects.object[1].frames.frame[1].smooth = false;
	for i = 2,frames do
	sequence.objects.object[1].frames.frame[i]= {}
	sequence.objects.object[1].frames.frame[i].x = -999
	sequence.objects.object[1].frames.frame[i].y = 0
	sequence.objects.object[1].frames.frame[i].z = 0
	sequence.objects.object[1].frames.frame[i].yawn = 0
	sequence.objects.object[1].frames.frame[i].pitch = 0
	sequence.objects.object[1].frames.frame[i].roll = 0
	sequence.objects.object[1].frames.frame[i].s = 0
	sequence.objects.object[1].frames.frame[i].keyframe = false;
	sequence.objects.object[1].frames.frame[i].smooth = false;

	
	end
	
	return sequence.objects.object[1];

	


end
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function HAK:RemoveKeyframeClick( wndHandler, wndControl, eMouseButton )
self.wndSelectedListItem_A:FindChild("Timeline"):GetData().frame[tonumber(self.wndEditAnim:FindChild("CurrentFrameBox"):GetText())].keyframe = false;
self:UpdateNumbers();
self:UpdatePixies(tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText()), nil)

self:SmoothenFrames();
end

function HAK:ViewInWorldButton( wndHandler, wndControl, eMouseButton )
if self.wndSelectedListItem_A == nil then return end
	nItemHandle = HousingLib.PreviewPlacedDecor(self.wndSelectedListItem_A:FindChild("Text"):GetData().IdLo,self.wndSelectedListItem_A:FindChild("Text"):GetData().IdHi)
	local x= tonumber(self.wndEditAnim:FindChild("XPos"):GetText())
	local y= tonumber(self.wndEditAnim:FindChild("YPos"):GetText())
	local z= tonumber(self.wndEditAnim:FindChild("ZPos"):GetText())
	local ya= tonumber(self.wndEditAnim:FindChild("Yaw"):GetText())
	local pi= tonumber(self.wndEditAnim:FindChild("Pitch"):GetText())
	local ro= tonumber(self.wndEditAnim:FindChild("Roll"):GetText())
	local s= tonumber(self.wndEditAnim:FindChild("Scale"):GetText())
	HousingLib.SetDecorPosition(x,y,z);
	HousingLib.SetDecorRotation(pi,ro,ya);
	HousingLib.ScaleDecor(s)
self.ItemHandle = nItemHandle;


	
end

function HAK:ImportFromWorldClick( wndHandler, wndControl, eMouseButton )
screeninfo = HousingLib.GetDecorIconInfo(self.ItemHandle)
if screeninfo ~= nil then
self.wndEditAnim:FindChild("XPos"):SetText(string.format("%.2f", screeninfo.fWorldPosX))
self.wndEditAnim:FindChild("YPos"):SetText(string.format("%.2f", screeninfo.fWorldPosY))
self.wndEditAnim:FindChild("ZPos"):SetText(string.format("%.2f", screeninfo.fWorldPosZ))
self.wndEditAnim:FindChild("Yaw"):SetText(string.format("%.2f", screeninfo.fYaw))
self.wndEditAnim:FindChild("Pitch"):SetText(string.format("%.2f", screeninfo.fPitch))
self.wndEditAnim:FindChild("Roll"):SetText(string.format("%.2f", screeninfo.fRoll))
self.wndEditAnim:FindChild("Scale"):SetText(string.format("%.2f", screeninfo.fScaleCurrent))

end


end

function HAK:UpdatestuffOnShow( wndHandler, wndControl )
	
end

function HAK:SetFrameClick( wndHandler, wndControl, eMouseButton )
if self.wndSelectedListItem_A ~= nil then
local currentframe = tonumber(self.wndEditAnim:FindChild("CurrentFrameBox"):GetText())
local frames =  self.wndSelectedListItem_A:FindChild("Timeline"):GetData()
frames.frame[currentframe].x = tonumber(self.wndEditAnim:FindChild("XPos"):GetText())
frames.frame[currentframe].y = tonumber(self.wndEditAnim:FindChild("YPos"):GetText())
frames.frame[currentframe].z = tonumber(self.wndEditAnim:FindChild("ZPos"):GetText())
frames.frame[currentframe].yawn = tonumber(self.wndEditAnim:FindChild("Yaw"):GetText())
frames.frame[currentframe].pitch = tonumber(self.wndEditAnim:FindChild("Pitch"):GetText())
frames.frame[currentframe].roll = tonumber(self.wndEditAnim:FindChild("Roll"):GetText())
frames.frame[currentframe].s = tonumber(self.wndEditAnim:FindChild("Scale"):GetText())
frames.frame[currentframe].smooth = self.wndEditAnim:FindChild("SmoothTransitionCheckbox"):IsChecked();





end
self:SmoothenFrames();
end

function HAK:SaveButtonClick( wndHandler, wndControl, eMouseButton )
local sequence = {}

sequence.Name = self.wndEditAnim:FindChild("TitleBox"):GetText()
	--check unique!
	for i = 1, #self.tItems do
		if self.tItems[i]:FindChild("Text"):GetText() == sequence.Name and self.wndSelectedListItem:GetData() ~= i then
			sequence.Name = sequence.Name.." - "..math.random(999999)
			--Print("Changed name to "..sequence.Name);
			self.wndEditAnim:FindChild("TitleBox"):SetText(sequence.Name)

		end
	end
	
--	sequence.Name = self.wndEditAnim:FindChild("TitleBox"):GetText()
	sequence.CurrentFrame=1
	sequence.TotalFrames=tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText())
	sequence.objects={}
	sequence.objects.object = {}
	local j=0
	while j < #self.tItems_A do
	j=j+1
	sequence.objects.object[j] = {}
	sequence.objects.object[j].objectinfo =self.tItems_A[j]:FindChild("Text"):GetData()

	sequence.objects.object[j].frames =self.tItems_A[j]:FindChild("Timeline"):GetData()
	end
	


self.wndSelectedListItem:FindChild("Text"):SetText(self.wndEditAnim:FindChild("TitleBox"):GetText())
self.wndSelectedListItem:FindChild("Text"):SetData(sequence)


self.SequenceList[self.wndSelectedListItem:GetData()] = sequence



self.wndEditAnim:Show(false,true)
self.wndMain:Show(true,true)
end

function HAK:CancelAnimationForm( wndHandler, wndControl, eMouseButton )
self.wndEditAnim:Show(false,true)
self.wndMain:Show(true,true)
end

function HAK:CancelCloseButton( wndHandler, wndControl, eMouseButton )

end

function HAK:StopAllClipsClick( wndHandler, wndControl, eMouseButton )
self.PlayList = {};
self.PlayList.sequence = {}

for i = 1,#self.tItems do
 if self.tItems[i] ~= nil then
	self.tItems[i]:FindChild("StopPlayButton"):Show(false,true)
	self.tItems[i]:FindChild("StartPlayButton"):Show(true,true)
 end
end

for i = 1,#self.tItems_A do
 if self.tItems_A[i] ~= nil then
	self.tItems_A[i]:FindChild("StopPreviewPlayButton"):Show(false,true)

	self.tItems_A[i]:FindChild("StartPreviewPlayButton"):Show(true,true)

 end
end

end

---------------------------------------------------------------------------------------------------
-- ListItemEditor Functions
---------------------------------------------------------------------------------------------------

function HAK:TeztClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
if eMouseButton ~= 0 then
 self.draggingframe = false;
 return; 
end
 self.draggingframe = true;
local min = 1;
local max = tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText());
local target = nLastRelativeMouseX + 1;

local newslider = math.floor((target/300) * max)+1
if newslider < min then newslider = min; end

if newslider > max then newslider = max; end

self.wndEditAnim:FindChild("FrameSelectSlider"):SetValue(newslider);
self.wndEditAnim:FindChild("CurrentFrameBox"):SetText(newslider);
self:UpdateNumbers();
return true;
end

function HAK:MouzeMove( wndHandler, wndControl, nLastRelativeMouseX, nLastRelativeMouseY )
if self.draggingframe ~= nil and  self.draggingframe == true then
self:TeztClick(wndHandler, wndControl, 0,nLastRelativeMouseX, nLastRelativeMouseY)
end

end

function HAK:StopClickTimeLine( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
self.draggingframe = false;
end

function HAK:DeleteObjectFromSequence( wndHandler, wndControl, eMouseButton )
local killindex = wndControl:GetParent():GetData()

--self.tItems_A[index]:Destroy();
--kill all pixies!!
    local	i=0


	while self.pixielist[i+1] ~= nil do
	i=i+1
	if allowsetindex == true then index = i; end
	if index == i then
	local j = 0
	while j < maxframes do 
	j=j+1
	if self.pixielist[i].pixie[j] ~= nil then
	self.tItems_A[i]:FindChild("Timeline"):DestroyPixie(self.pixielist[i].pixie[j])
	--Print("Killed one");
	self.pixielist[i].pixie[j] = nil;
end
self.pixielist[i] = nil
end
end
end

--rebuild sequence


local sequence = {}
	sequence.CurrentFrame=1
	sequence.TotalFrames=tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText())
	sequence.objects={}
	sequence.objects.object = {}
	local j=0
	for i = 1,#self.tItems_A do
	if i ~= killindex then
	j=j+1
	sequence.objects.object[j] = {}
	sequence.objects.object[j].objectinfo = self.tItems_A[i]:FindChild("Text"):GetData()

	sequence.objects.object[j].frames = self.tItems_A[i]:FindChild("Timeline"):GetData()
	
	end
	end
	
	


self:PopulateItemList_A(sequence)
self:UpdatePixies(tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText()), nil)

end

function HAK:AnimatorItemPlayClick(wndControl)
local tempname = wndControl:GetParent():FindChild("StartPreviewPlayButton"):GetData()

--if true == true then return end


if wndControl:GetParent() == nil then return end
local sequence = {}
	sequence.Name = tempname
	sequence.CurrentFrame=1
	sequence.TotalFrames=tonumber(self.wndEditAnim:FindChild("MaxFramesEditBox"):GetText())
	sequence.objects={}
	sequence.objects.object = {}
	local j=0
	
	j=j+1
	sequence.objects.object[j] = {}
	sequence.objects.object[j].objectinfo =wndControl:GetParent():FindChild("Text"):GetData()

	sequence.objects.object[j].frames =wndControl:GetParent():FindChild("Timeline"):GetData()
	

local index = #self.PlayList.sequence +1
self.PlayList.sequence[index] = {}
self.PlayList.sequence[index] = sequence;


end
function HAK:OnSave(eLevel)
    if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Realm then
        return nil
    end

    -- create a table to hold our data
    local tSave = {}
	i=0;
	for i= 1,#self.tItems   do
        -- for each player in our list, create a table using the name as our key
        tSave[i] = {}
        -- save a table version of the color
        tSave[i] = self.tItems[i]:FindChild("Text"):GetData();


    end

    -- simply return this value and Apollo will save the file!
    return tSave
end
function HAK:OnRestore(eLevel, tData)
if tData ~= nil then
self.SequenceList = tData
end

end

function HAK:StopPreviewPlayButtonClick( wndHandler, wndControl, eMouseButton )
wndControl:GetParent():FindChild("StopPreviewPlayButton"):Show(false,true);
wndControl:GetParent():FindChild("StartPreviewPlayButton"):Show(true,true);
self:StopaSequence(wndControl:GetParent():FindChild("StartPreviewPlayButton"):GetData())
end

function HAK:StartPreviewPlayButtonClick( wndHandler, wndControl, eMouseButton )
wndControl:SetData("tempitem".. self.wndEditAnim:FindChild("TitleBox"):GetText() .." "..wndControl:GetParent():GetData());
wndControl:GetParent():FindChild("StopPreviewPlayButton"):Show(true,true);
wndControl:GetParent():FindChild("StartPreviewPlayButton"):Show(false,true);
self:AnimatorItemPlayClick(wndControl)
end

function HAK:StopaSequence(name)
 local newlist = {}
 newlist.sequence={}


for i = 1,#self.PlayList.sequence do
 if self.PlayList.sequence[i].Name ~= name then
  newlist.sequence[#newlist.sequence +1] = self.PlayList.sequence[i]
 end


end
self.PlayList = newlist;


end

-----------------------------------------------------------------------------------------------
-- HAK Instance
-----------------------------------------------------------------------------------------------
local HAKInst = HAK:new()
HAKInst:Init()
